from tensorflow.python.keras import Sequential, Input, Model
from tensorflow.python.keras.layers import Flatten, Dense, LeakyReLU


def build_discriminator(self):
    # 使用Sequential方式构建判别器
    model = Sequential()

    # 将输入的图片展平并输入全连接层
    model.add(Flatten(input_shape=self.img_shape))
    model.add(Dense(512))
    model.add(LeakyReLU(alpha=0.2))

    model.add(Dense(256))
    model.add(LeakyReLU(alpha=0.2))

    model.add(Dense(1, activation='sigmoid'))  # 最后通过维度是1的全连接层
    model.summary()

    img = Input(shape=self.img_shape)
    validity = model(img)

    return Model(img, validity)